org.apache.ignite.internal

## Interface IgniteEx

All Superinterfaces:
  AutoCloseable, Ignite

All Known Implementing Classes:
  IgniteKernal

    public interface IgniteEx
    extends Ignite

Extended Grid interface which provides some additional methods required for kernal and Visor.

### Method Summary

Methods
`boolean` `allEventsUserRecordable(int[] types)` Checks whether all provided events are user-recordable.
`Collection<IgniteInternalCache<?,?>>` `cachesx(IgnitePredicate<? super IgniteInternalCache<?,?>>... p)` Gets configured cache instance that satisfy all provided predicates including non-public caches.
`<K,V> IgniteInternalCache<K,V>` `cachex(String name)` Gets the cache instance for the given name if one is configured or `null` otherwise returning even non-public caches.
`IgniteClusterEx` `cluster()` Gets an instance of `IgniteCluster` interface.
`GridKernalContext` `context()` Internal context.
`boolean` `destroyCache0(String cacheName, boolean sql)` Stops dynamically started cache.
`boolean` `eventUserRecordable(int type)` Checks if the event type is user-recordable.
`<K,V> IgniteBiTuple<IgniteCache<K,V>,Boolean>` `getOrCreateCache0(CacheConfiguration<K,V> cacheCfg, boolean sql)` Gets existing cache with the given name or creates new one with the given configuration.
`Hadoop` `hadoop()` Get Hadoop facade.
`IgniteFileSystem` `igfsx(String name)` Get IGFS instance returning null if it doesn't exist.
`boolean` `isJmxRemoteEnabled()` Whether or not remote JMX management is enabled for this node.
`boolean` `isRestartEnabled()` Whether or not node restart is enabled.
`String` `latestVersion()` Get latest version in string form.
`ClusterNode` `localNode()` Gets local grid node.
`<K extends GridCacheUtilityKey,V> IgniteInternalCache<K,V>` `utilityCache()` Gets utility cache.

### Methods inherited from interface org.apache.ignite.Ignite

`active, active, addCacheConfiguration, affinity, atomicLong, atomicLong, atomicReference, atomicReference, atomicSequence, atomicSequence, atomicStamped, atomicStamped, binary, cache, cacheNames, close, compute, compute, configuration, countDownLatch, createCache, createCache, createCache, createCaches, createNearCache, dataStreamer, destroyCache, destroyCaches, events, events, executorService, executorService, fileSystem, fileSystems, getOrCreateCache, getOrCreateCache, getOrCreateCache, getOrCreateCaches, getOrCreateNearCache, log, memoryMetrics, memoryMetrics, message, message, name, persistentStoreMetrics, plugin, queue, reentrantLock, resetLostPartitions, scheduler, semaphore, services, services, set, transactions, version`

### Method Detail

#### utilityCache

    <K extends GridCacheUtilityKey,V> IgniteInternalCache<K,V> utilityCache()

Gets utility cache.

Returns:
  Utility cache.

#### cachex

    @Nullable
    <K,V> IgniteInternalCache<K,V> cachex(String name)

Gets the cache instance for the given name if one is configured or `null` otherwise returning even non-public caches.

Type Parameters:
  `K` - Key type.
  `V` - Value type.
Parameters:
  `name` - Cache name.
Returns:
  Cache instance for given name or `null` if one does not exist.

#### cachesx

    Collection<IgniteInternalCache<?,?>> cachesx(@Nullable
                                               IgnitePredicate<? super IgniteInternalCache<?,?>>... p)

Gets configured cache instance that satisfy all provided predicates including non-public caches. If no predicates provided - all configured caches will be returned.

Parameters:
  `p` - Predicates. If none provided - all configured caches will be returned.
Returns:
  Configured cache instances that satisfy all provided predicates.

#### getOrCreateCache0

    <K,V> IgniteBiTuple<IgniteCache<K,V>,Boolean> getOrCreateCache0(CacheConfiguration<K,V> cacheCfg,
                                                                  boolean sql)
                                                              throws javax.cache.CacheException

Gets existing cache with the given name or creates new one with the given configuration.

If a cache with the same name already exists, this method will not check that the given configuration matches the configuration of existing cache and will return an instance of the existing cache.

Parameters:
  `cacheCfg` - Cache configuration to use.
  `sql` - `true` if this call is triggered by SQL command `CREATE TABLE`, `false` otherwise.
Returns:
  Tuple [Existing or newly created cache; `true` if cache was newly crated, `false` otherwise]
Throws:
  `javax.cache.CacheException` - If error occurs.

#### destroyCache0

    boolean destroyCache0(String cacheName,
                        boolean sql)
                          throws javax.cache.CacheException

Stops dynamically started cache.

Parameters:
  `cacheName` - Cache name to stop.
  `sql` - `true` if only cache created with SQL command `CREATE TABLE` should be affected, `false` otherwise.
Returns:
  `true` if cache has been stopped as the result of this call, `false` otherwise.
Throws:
  `javax.cache.CacheException` - If error occurs.

#### eventUserRecordable

    boolean eventUserRecordable(int type)

Checks if the event type is user-recordable.

Parameters:
  `type` - Event type to check.
Returns:
  `true` if passed event should be recorded, `false` - otherwise.

#### allEventsUserRecordable

    boolean allEventsUserRecordable(int[] types)

Checks whether all provided events are user-recordable.

Note that this method supports only predefined Ignite events.

Parameters:
  `types` - Event types.
Returns:
  Whether all events are recordable.
Throws:
  `IllegalArgumentException` - If `types` contains user event type.

#### isJmxRemoteEnabled

    boolean isJmxRemoteEnabled()

Whether or not remote JMX management is enabled for this node.

Returns:
  `True` if remote JMX management is enabled - `false` otherwise.

#### isRestartEnabled

    boolean isRestartEnabled()

Whether or not node restart is enabled.

Returns:
  `True` if restart mode is enabled, `false` otherwise.

#### igfsx

    @Nullable
    IgniteFileSystem igfsx(String name)

Get IGFS instance returning null if it doesn't exist.

Parameters:
  `name` - IGFS name.
Returns:
  IGFS.

#### hadoop

    Hadoop hadoop()

Get Hadoop facade.

Returns:
  Hadoop.

#### cluster

    IgniteClusterEx cluster()

Gets an instance of `IgniteCluster` interface.

Specified by:
  `cluster` in interface `Ignite`
Returns:
  Instance of `IgniteCluster` interface.

#### latestVersion

    @Nullable
    String latestVersion()

Get latest version in string form.

Returns:
  Latest version.

#### localNode

    ClusterNode localNode()

Gets local grid node.

Returns:
  Local grid node.

#### context

    GridKernalContext context()

Internal context.

Returns:
  Kernal context.

2017 Copyright © Apache Software Foundation

Follow @ApacheIgnite

Ignite Fabric | : ver. 2.1.0
Release Date | : July 20 2017